# TODO
# - secure webpages and dirs (separate htdocs and includes)
#
# Conditional build:
%bcond_with	apidocs	# with apidocs. not finished
#
Summary:	MediaWiki - the collaborative editing software that runs Wikipedia
Summary(pl.UTF-8):	MediaWiki - oprogramowanie do wspólnej edycji, na którym działa Wikipedia
Name:		mediawiki
Version:	1.20.4
Release:	2
License:	GPL v2
Group:		Applications/WWW
Source0:	http://download.wikimedia.org/mediawiki/1.20/%{name}-%{version}.tar.gz
# Source0-md5:	ad0e4c2319bc80713da2b8bf74091c3f
Source1:	%{name}-apache.conf
Source2:	%{name}-httpd.conf
Patch0:		%{name}-confdir2.patch
URL:		http://www.mediawiki.org/
BuildRequires:	sed >= 4.0
%if %{with apidocs}
BuildRequires:	php-cli
BuildRequires:	php-pear-PhpDocumentor
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
Requires:	php(core) >= 5.0
Requires:	php(mysql)
Requires:	php(pcre)
Requires:	php(session)
Requires:	php(xml)
# includes/UserMailer.php:
#Requires:	php-pear-Mail
# Optional
Requires:	webapps
#Suggests:	ImageMagick or php-gd for thumbnails
#Suggests:	php-mmcache || php4-mmcache
#Suggests:	php-zlib
Conflicts:	apache-base < 2.4.0-1
BuildArch:	noarch
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_noautoreq	^/usr/bin/hphpi$

%define		_appdir		%{_datadir}/%{name}
%define		_vardir		%{_sharedstatedir}/%{name}
%define		_webapps	/etc/webapps
%define		_webapp		%{name}
%define		_sysconfdir	%{_webapps}/%{_webapp}

%description
MediaWiki is the collaborative editing software that runs Wikipedia,
for a list of features please consult:
<http://meta.wikimedia.org/wiki/MediaWiki_feature_list>.

%description -l pl.UTF-8
MediaWiki to oprogramowanie do wspólnej edycji, na którym działa
Wikipedia. Listę możliwości można znaleźć pod adresem:
<http://meta.wikimedia.org/wiki/MediaWiki_feature_list>.

%package setup
Summary:	MediaWiki setup package
Summary(pl.UTF-8):	Pakiet do wstępnej konfiguracji MediaWiki
Group:		Applications/WWW
Requires:	%{name} = %{epoch}:%{version}-%{release}
Requires:	php(posix)

%description setup
Install this package to configure initial MediaWiki installation. You
should uninstall this package when you're done, as it considered
insecure to keep the setup files in place.

%description setup -l pl.UTF-8
Ten pakiet należy zainstalować w celu wstępnej konfiguracji MediaWiki
po pierwszej instalacji. Potem należy go odinstalować, jako że
pozostawienie plików instalacyjnych mogłoby być niebezpieczne.

%prep
%setup -q
%patch0 -p1

find '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v
find -name '*.php5' | xargs rm -v

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sysconfdir},%{_appdir},%{_vardir}}

cp -a mw-config extensions includes languages maintenance resources skins $RPM_BUILD_ROOT%{_appdir}
cp -a cache images $RPM_BUILD_ROOT%{_vardir}
cp *.php $RPM_BUILD_ROOT%{_appdir}

ln -s %{_vardir}/cache $RPM_BUILD_ROOT%{_appdir}
ln -s %{_vardir}/images $RPM_BUILD_ROOT%{_appdir}

install %{SOURCE1} $RPM_BUILD_ROOT%{_sysconfdir}/apache.conf
install %{SOURCE2} $RPM_BUILD_ROOT%{_sysconfdir}/httpd.conf

%clean
rm -rf $RPM_BUILD_ROOT

%post setup
chmod 770 %{_sysconfdir}

%postun setup
if [ "$1" = "0" ]; then
	chmod 750 %{_sysconfdir}
	if [ -f %{_sysconfdir}/LocalSettings.php ]; then
		chown root:http %{_sysconfdir}/LocalSettings.php
		chmod 640 %{_sysconfdir}/LocalSettings.php
	fi
fi

%triggerin -- apache1 < 1.3.37-3, apache1-base
%webapp_register apache %{_webapp}

%triggerun -- apache1 < 1.3.37-3, apache1-base
%webapp_unregister apache %{_webapp}

%triggerin -- apache-base
%webapp_register httpd %{_webapp}

%triggerun -- apache-base
%webapp_unregister httpd %{_webapp}

%triggerpostun -- %{name} < 1.5.3-0.2
# nuke very-old config location (this mostly for Ra)
if [ -f /etc/httpd/httpd.conf ]; then
	sed -i -e "/^Include.*%{name}.conf/d" /etc/httpd/httpd.conf
	/usr/sbin/webapp register httpd %{_webapp}
	httpd_reload=1
fi

# migrate from httpd (apache2) config dir
if [ -f /etc/httpd/%{name}.conf.rpmsave ]; then
	cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
	mv -f /etc/httpd/%{name}.conf.rpmsave %{_sysconfdir}/httpd.conf
	/usr/sbin/webapp register httpd %{_webapp}
	httpd_reload=1
fi

# migrate from apache-config macros
if [ -f /etc/%{name}/apache.conf.rpmsave ]; then
	if [ -d /etc/apache/webapps.d ]; then
		cp -f %{_sysconfdir}/apache.conf{,.rpmnew}
		cp -f /etc/%{name}/apache.conf.rpmsave %{_sysconfdir}/apache.conf
	fi

	if [ -d /etc/httpd/webapps.d ]; then
		cp -f %{_sysconfdir}/httpd.conf{,.rpmnew}
		cp -f /etc/%{name}/apache.conf.rpmsave %{_sysconfdir}/httpd.conf
	fi
	rm -f /etc/%{name}/apache.conf.rpmsave
fi

# migrating from earlier apache-config?
if [ -L /etc/apache/conf.d/99_%{name}.conf ] || [ -L /etc/httpd/httpd.conf/99_%{name}.conf ]; then
	if [ -L /etc/apache/conf.d/99_%{name}.conf ]; then
		rm -f /etc/apache/conf.d/99_%{name}.conf
		/usr/sbin/webapp register apache %{_webapp}
		apache_reload=1
	fi
	if [ -L /etc/httpd/httpd.conf/99_%{name}.conf ]; then
		rm -f /etc/httpd/httpd.conf/99_%{name}.conf
		/usr/sbin/webapp register httpd %{_webapp}
		httpd_reload=1
	fi
else
	# no earlier registration. assume migration from Ra
	if [ -d /etc/apache/webapps.d ]; then
		/usr/sbin/webapp register apache %{_webapp}
		apache_reload=1
	fi
	if [ -d /etc/httpd/webapps.d ]; then
		/usr/sbin/webapp register httpd %{_webapp}
		httpd_reload=1
	fi
fi

if [ "$httpd_reload" ]; then
	%service httpd reload
fi
if [ "$apache_reload" ]; then
	%service apache reload
fi

%triggerpostun -- %{name} < 1.6.0
%banner -e %{name}-1.6 <<EOF
You may use command line upgrade script maintenance/update.php to
upgrade from previous version.
EOF

%files
%defattr(644,root,root,755)
%doc docs FAQ HISTORY INSTALL README RELEASE-NOTES-1.20 UPGRADE *.sample
%dir %attr(750,root,http) %{_sysconfdir}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/apache.conf
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) %{_sysconfdir}/httpd.conf

%dir %{_appdir}
%{_appdir}/*.php
%{_appdir}/languages
%{_appdir}/cache
%{_appdir}/images
%{_appdir}/extensions
%{_appdir}/resources
%{_appdir}/skins
%{_appdir}/includes
%{_appdir}/maintenance

%dir %attr(750,root,http) %{_vardir}
%dir %attr(770,root,http) %{_vardir}/cache
%{_vardir}/cache/.htaccess
%dir %attr(770,root,http) %{_vardir}/images
%{_vardir}/images/.htaccess
%{_vardir}/images/README

%files setup
%defattr(644,root,root,755)
%dir %attr(775,root,http) %{_appdir}/mw-config
%{_appdir}/mw-config/index.php
%{_appdir}/mw-config/overrides.php
%changelog
* Wed May 15 2013 PLD Linux Team <feedback@pld-linux.org>
- For complete changelog see: http://git.pld-linux.org/?p=packages/mediawiki.git;a=log;h=master

* Wed May 15 2013 Jan Rękorajski <baggins@pld-linux.org> 3848a96
- migrated to apache 2.4

* Mon May 13 2013 Piotr Ziecik <kosmo@angel.net.pl> c3d11b2
- updated to 1.20.4.

* Tue Jan 15 2013 Piotr Ziecik <kosmo@angel.net.pl> c8a7bec
- updated to 1.20.2.

* Thu Aug 23 2012 Elan Ruusamäe <glen@delfi.ee> c65ad78
- use php(core) as dependency to require php version
- release 1 (by relup.sh)

* Fri Jul 06 2012 Tomasz Pala <gotar@pld-linux.org> 8be0de7
- upgraded to 1.18.4

* Fri Feb 17 2012 kosmo <kosmo@pld-linux.org> ea11228
- place cache and images in writeable location.
- release 1

* Wed Feb 08 2012 kosmo <kosmo@pld-linux.org> 05d904e
- updated to 1.18.1

* Wed Dec 28 2011 kosmo <kosmo@pld-linux.org> 87f2a94
- updated to 1.18.0

* Wed Dec 02 2009 Elan Ruusamäe <glen@pld-linux.org> 6ce579d
- R: session; http://lists.pld-linux.org/mailman/pipermail/pld-devel-en/2009-December/021307.html; rel 2

* Thu Mar 26 2009 duddits <duddits@pld-linux.org> 3d7f338
- up to 1.13.5

* Mon Dec 29 2008 duddits <duddits@pld-linux.org> 2d5aae2
- up to 1.3.13

* Tue Nov 25 2008 duddits <duddits@pld-linux.org> 4e0c105
- up to 1.13.2

* Tue Sep 30 2008 Jakub Bogusz <qboosh@pld-linux.org> e5534f8
- complete URL

* Tue Sep 30 2008 duddits <duddits@pld-linux.org> eca04d2
- up to 1.13.1
- confdir2.patch updated

* Tue Sep 30 2008 duddits <duddits@pld-linux.org> 7553818
- patch updated to fit 1.13.1

* Sat Mar 29 2008 Tomasz Pala <gotar@pld-linux.org> d06b2a6
- set open_basedir restriction

* Thu Mar 27 2008 Elan Ruusamäe <glen@pld-linux.org> f389e0e
- update to 1.12.0

* Fri Dec 28 2007 zbyniu <zbyniu@pld-linux.org> 6c6e056
- up to 1.10.2

* Sun Jul 15 2007 Elan Ruusamäe <glen@pld-linux.org> 92dbc68
- 1.10.1

* Wed Jun 06 2007 Elan Ruusamäe <glen@pld-linux.org> 6bc9960
- 1.10.0

